﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Services.Hive.DataAccess;

namespace HeuristicLab.Services.Hive {

  public class ServiceLocator {
    private static ServiceLocator instance;
    public static ServiceLocator Instance {
      get {
        if (instance == null) instance = new ServiceLocator();
        return instance;
      }
    }

    private IHiveDao hiveDao;
    public IHiveDao HiveDao {
      get {
        if (hiveDao == null) hiveDao = new HiveDao();
        return hiveDao;
      }
    }
    
    private TransactionManager transactionManager;
    public TransactionManager TransactionManager {
      get {
        if (transactionManager == null) transactionManager = new TransactionManager();
        return transactionManager;
      }
    }

    private IAuthorizationManager authorizationManager;
    public IAuthorizationManager AuthorizationManager {
      get {
        if (authorizationManager == null) authorizationManager = new AuthorizationManager();
        return authorizationManager;
      }
    }

    private Hive hive;
    public Hive Hive {
      get {
        if (hive == null) hive = new Hive();
        return hive;
      }
    }
  }
}
